<template>
  <box-content>
    <!-- 搜索框 -->
    <div class="search">
      <el-form :inline="true" size="mini" class="base-search-form">
        <el-form-item label="Code:">
          <el-input :maxLength="$inputMax" v-model="searchData.Code" clearable style="width:120px;" />
        </el-form-item>
        <el-form-item label="KeyName:">
          <el-input :maxLength="$inputMax" v-model="searchData.KeyName" clearable style="width:120px;" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="handleReset">Reset</el-button>
          <el-button type="primary" @click="handleSearch">Search</el-button>
        </el-form-item>
      </el-form>
      <span style="margin-left:auto">
        <el-button type="primary" size="mini" @click="handleAdd">New</el-button>
      </span>
    </div>
    <el-table
      v-loading="loading"
      v-adaptive="{bottomOffset:45}"
      :data="list"
      stripe
      size="small"
      height="100"
    >
      <el-table-column type="index" width="60" />
      <el-table-column
        prop="Code"
        label="Code"
        show-overflow-tooltip
      />
      <el-table-column
        prop="KeyName"
        label="KeyName"
        show-overflow-tooltip
      />
      <el-table-column
        prop="Description"
        label="Description"
        show-overflow-tooltip
      />
      <el-table-column
        prop="Value"
        label="Value"
        show-overflow-tooltip
      />
      <el-table-column
        prop="ValueCN"
        label="ValueCN"
        show-overflow-tooltip
      />
      <el-table-column label="Is Enable" width="100" fixed="right">
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.IsEnable"
            :active-value="true"
            :inactive-value="false"
            @change="(event) => {return switchChange(event, scope.row)}"
          />
        </template>
      </el-table-column>
      <el-table-column label="Action" width="200" fixed="right">
        <template slot-scope="scope">
          <el-button
            type="primary"
            size="mini"
            @click="handleEdit(scope.row)"
          >
            Edit
          </el-button>
          <el-button
            type="danger"
            size="mini"
            @click="handleDelete(scope.row)"
          >
            Delete
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <DictionaryTypeConfigForm ref="DictionaryTypeConfigForm" @getList="getList" />
  </box-content>
</template>
<script>
import { getBasicDicList, deleteDictionary, addOrUpdateBasicDic } from '@/api/dictionary'
import DictionaryTypeConfigForm from './DictionaryTypeConfigForm'
import BoxContent from '@/components/BoxContent'

const searchDataDefault = () => {
  return {
    asc: true,
    sortField: '',
    code: '',
    keyName: '',
    IsConfig: true,
    PageIndex: 1,
    PageSize: 20
  }
}
export default {
  name: 'DictionaryConfig',
  components: { BoxContent, DictionaryTypeConfigForm },
  data() {
    return {
      searchData: searchDataDefault(),
      list: [],
      total: 0,
      loading: false,
      rowData: {},
      model_cfg: { visible: false, showClose: true, width: '600px', title: '' }
    }
  },
  mounted() {
    this.getList()
  },
  methods: {
    switchChange(event, item) {
      this.loading = true
      addOrUpdateBasicDic(item).then(res => {
        this.$message.success(this.$t('common:message:savedSuccessfully'))
        this.loading = false
      }).catch(() => {
        this.loading = false
      })
    },
    handleEdit(row) {
      this.$nextTick(() => {
        this.$refs['DictionaryTypeConfigForm'].openDialog('DictionaryTypeConfig', row)
      })
    },
    handleAdd() {
      this.$nextTick(() => {
        this.$refs['DictionaryTypeConfigForm'].openDialog('DictionaryTypeConfig', {})
      })
    },
    handleDelete(row) {
      this.$confirm('Sure to delete?', {
        type: 'warning',
        distinguishCancelAndClose: true,
        confirmButtonText: 'Ok',
        cancelButtonText: 'Cancel'
      })
        .then(() => {
          this.loading = true
          deleteDictionary(row.Id)
            .then(res => {
              this.loading = false
              if (res.IsSuccess) {
                this.list.splice(this.list.findIndex(item => item.Id === row.Id), 1)
                this.$message.success(this.$t('common:message:deletedSuccessfully'))
              }
            }).catch(() => { this.loading = false })
        })
    },
    // 获取匿名化配置信息
    getList() {
      this.loading = true
      getBasicDicList(this.searchData).then(res => {
        this.loading = false
        this.list = res.Result.CurrentPageData
      }).catch(() => { this.loading = false })
    },
    // 查询
    handleSearch() {
      this.getList()
    },
    // 重置
    handleReset() {
      this.searchData = searchDataDefault()
      this.getList()
    }
  }
}
</script>
